import 'dart:async';

import 'dart:mirrors';
import 'dart:io';
import 'dart:convert';

import 'package:verbal_expressions/verbal_expressions.dart';

Future main() async {
  try {
    print('Call a global functions specified in grind.dart:');
    stdout.write('> ');
    await for (final byte in stdin) {
      String input = SYSTEM_ENCODING.decode(byte).trim();
      String method = input.split('(').first;
      var arguments = input.split('(').last;
      var verbalExpression = new VerbalExpression()..anyOf('()');
      arguments = arguments.replaceAll(verbalExpression.toRegExp(), '');
      arguments = "[$arguments]";
      arguments = JSON.decode(arguments);
      var a = findMethod(MirrorSystem.getSymbol(method))?.apply(arguments);
      await a.reflectee;
      stdout.write('> ');
    }
  } catch(e) {
    print(e);
  }
}


ClosureMirror findMethod(Symbol symbol) {
  try {
    return currentMirrorSystem().isolate.rootLibrary.getField(symbol);
  } catch (e) {
    try {
      return currentMirrorSystem()
          .libraries
          .values
          .lastWhere((l) => l.declarations.containsKey(symbol))
          .getField(symbol);
    } catch (e) {
      print('Method $symbol not found');
      return null;
    }
  }
}
